第三天-E-hdu1069-F-hdu-1171-G-1176

题目链接:hdu1069

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn’t be stacked.

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

Input
The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.

Output
For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format “Case case: maximum height = height”.

Sample Input
1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0

Sample Output
Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342

题解:现在给你M种长方体,计算,最高能堆多高。
要求位于上面的长方体的长要大于(注意不是大于等于)下面长方体的长,上面长方体的宽大于下面长方体的宽。

解题:
一个长方体,可以有6种不同的摆法。
因为数据中 长方体种类最多30种,也就是说数组最大需要180
多开一点到200就行

当然,长方体先要以长度排序,长度相同则宽度小的在上。
使用结构体存储长宽高再用sort函数进行排序
然后用dp[i]来存,到第i个木块,最高可以累多高。

我的代码:

#include <iostream>
#include <cstdio> 
#include<cstring>
#include<algorithm>
using namespace std;
#define maxn 200
int dp[maxn];
struct v
{
	int c;//长
	int k;//宽
	int h;//高
};
int max(int a, int b)
{
	return a > b ? a : b;
}
bool compare(v a, v b)//比较
{
	if (a.c == b.c)    return a.k < b.k;
	return a.c < b.c;
}
int main()
{
	int i = 0, j, n, x, y, z, num; int cas = 1, max1 = 0;
	v a[maxn];
	while (cin>>n&&n)//n为种类
	{
		num = 0;
		while (n--)
		{
			cin>>x>>y>>z;//6种情况...
			a[num].c = x; a[num].k = y; a[num++].h = z;
			a[num].c = x; a[num].k = z; a[num++].h = y;
			a[num].c = y; a[num].k = x; a[num++].h = z;
			a[num].c = y; a[num].k = z; a[num++].h = x;
			a[num].c = z; a[num].k = y; a[num++].h = x;
			a[num].c = z; a[num].k = x; a[num++].h = y;
		}
		sort(a, a + num, compare);
		memset(dp, 0, sizeof(dp));
		dp[0] = a[0].h;
		for (i = 1; i < num; ++i)
		{
			int max = 0;
			for (j = 0; j < i; ++j)
			{
				if (a[j].c < a[i].c && a[j].k < a[i].k)
					max = max > dp[j] ? max : dp[j];
			}
			dp[i] = a[i].h + max;
		}
		max1 = 0;
		for (i = 0; i < num; i++)
		{
			max1 = dp[i] > max1 ? dp[i] : max1;
		}
		cout << "Case " << cas++ << ": maximum height = " << max1 << endl;
	}
	return 0;
}

hdu-1171

#include <iostream>
#include<cstring>
using namespace std;
#define maxn 256050
int v[60], num[60], dp[maxn];
int max(int a, int b)
{
	return a > b ? a : b;
}
int main()
{
	int n;
	while (cin >> n && (n>0))
	{
		memset(dp, 0, sizeof(dp));
		int sum = 0, e = 0, a, b;
		for (int i = 0; i < n; i++)
		{
			cin >> a >> b;
			v[i] = a;
			num[i] = b;
			sum += a * b;
		}
		for (int i = 0; i < n; i++)
			for (int j = 0; j < num[i]; j++)
				for (int k = sum / 2; k >= v[i]; k--)
				{
					dp[k] = max(dp[k], dp[k - v[i]] + v[i]);
				}
		cout << sum - dp[sum / 2] << " " << dp[sum / 2] << endl;
	}
}

hdu-1176

#include <iostream>
#include <cstdio> 
#include<cstring>
using namespace std;
#define maxn 100005
int dp[maxn][15];
int max(int a, int b)
{
	return a > b ? a : b;
}
int main()
{
	int i, j, T = 0, t, n, x;
	while (~scanf("%d", &n) && n)
	{
		memset(dp, 0, sizeof(dp));
		for (i = 0; i < n; i++)
		{
			scanf("%d%d", &x, &t);
			dp[t][x]++;
			T = t > T ? t : T;
		}
		for (i = T; i > 0; i--)
			for (j = 0; j <= 10; j++)
			{
				if (j == 0)
					dp[i - 1][0] += max(dp[i][0], dp[i][1]);
				else if (j == 10)
					dp[i - 1][10] += max(dp[i][9], dp[i][10]);
				else
					dp[i - 1][j] += max(dp[i][j - 1], max(dp[i][j], dp[i][j + 1]));
			}
		printf("%d\n", dp[0][5]);
	}
}

猜你喜欢

转载自blog.csdn.net/weixin_43866317/article/details/86619303